-- Differences with Spagic 2.0.0 --

-- Solve SPAGIC-153 BUGS
-- IF USING SPAGIC 2.0 spagic-mysql-oracle.ddl
-- IN SPAGIC 2.1 THIS IS NOT REQUIRED
ALTER TABLE process modify process_version varchar(20);

ALTER TABLE property MODIFY code varchar(200);

-- Differences with Spagic 2.1.0 --

ALTER TABLE transition_instance ADD COLUMN attachment_in int DEFAULT 0 AFTER transition_data;

ALTER TABLE transition_instance ADD COLUMN attachment_out int DEFAULT 0 AFTER attachment_in;

ALTER TABLE transition_instance MODIFY TRANSITION_DATA MEDIUMBLOB;

ALTER TABLE transition_instance ADD COLUMN transition_data_out MEDIUMBLOB AFTER TRANSITION_DATA;

ALTER TABLE process ADD COLUMN monitor_enabled BOOLEAN NOT NULL DEFAULT true AFTER `state`;

-- Tables for event handling --
Create table wait_data (
	id_wait Bigint(20) NOT NULL AUTO_INCREMENT,
	id_correlation Varchar(200) NOT NULL,
	wait_timestamp Timestamp NOT NULL,
	expiry_timestamp Timestamp NULL DEFAULT NULL,
	expiration_action Varchar(500),
	eventType Varchar(200) NOT NULL DEFAULT "GenericEvent",
	exchange Blob,
	signalUri Varchar(500),
	destinationUri Varchar(500),
 Primary Key (id_wait)) ENGINE = InnoDB;

Create table wait_data_attribute (
	id_wait_data_attribute Bigint NOT NULL AUTO_INCREMENT,
	id_wait Bigint NOT NULL,
	name Varchar(200) NOT NULL,
	att_value Varchar(500),
 Primary Key (id_wait_data_attribute)) ENGINE = InnoDB;

CREATE VIEW bc_input_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS input_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)				
				AND s.id_step = t.id_step_source
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_start = 1 AND logJournal.id_state IN (0, 3)) 
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND logJournal.id_state=3 )
						) 				
	group by s.id_step;

CREATE VIEW bc_output_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS output_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)								
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_end = 1 AND logJournal.id_state=1 AND s.id_step = t.id_step_target)
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND s.id_step = t.id_step_source AND logJournal.id_state=4 )
            OR (s.is_start = 1 AND logJournal.id_state = 4 AND s.id_step = t.id_step_source)						
						) 				
	group by s.id_step;
	
CREATE VIEW bc_error_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS error_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)								
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_start = 1 AND s.id_step = t.id_step_source AND logJournal.id_state IN (2, 5))
						OR(s.is_end = 1 AND s.id_step = t.id_step_target AND logJournal.id_state IN (2, 5))
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND logJournal.id_state=5
								AND (s.id_step = t.id_step_target OR s.id_step = t.id_step_source))
						) 				
	group by s.id_step;
	
Alter table wait_data_attribute add Foreign Key (id_wait) references wait_data (id_wait) on delete  restrict on update  restrict;

-- Exceution Time ( AZ 09/07/2008 )
ALTER TABLE transition_instance ADD COLUMN transition_execution_time Bigint(20) DEFAULT NULL AFTER transition_end;
ALTER TABLE process_instance ADD COLUMN  executiontime Bigint(20) DEFAULT NULL AFTER enddate;

-- Ricalcola tempi di esecuzione
UPDATE process_instance
SET executiontime = TIMESTAMPDIFF(SECOND,startdate,enddate) * 1000;

-- Changes for Deploy Tool
ALTER TABLE attribute ADD CONSTRAINT UNIQUE name (name);

--Preference Query
Create table search_query (
   id_query Bigint(20) NOT NULL AUTO_INCREMENT,
   label Varchar(100) NOT NULL UNIQUE,
   query Text NOT NULL,
Primary Key (id_query));

-- Differences with Spagic 2.3.0 --

ALTER TABLE process_instance DROP INDEX idx_correlation_id,
 ADD INDEX idx_process_instance_01 (id_correlation);
/* Cannot be unique due to restarted instances */
Create Index idx_transition_instance_01 ON transition_instance (id_message);
Create Index idx_wait_data_01 ON wait_data (id_correlation);
Create Index idx_log_journal_01 ON log_journal (id_journal);
Create Index idx_log_journal_02 ON log_journal (id_state);

