------ Differences with Spagic 2.0.0 ------

-- Solve SPAGIC-153 BUGS
-- IF USING SPAGIC 2.0 spagic-metadb-oracle.ddl
-- IN SPAGIC 2.1 THIS IS NOT REQUIRED
ALTER TABLE PROCESS modify process_version varchar2(20);

-- ENABLE THE PROPERTY NAME ( code ) TO BE LONG 200  
ALTER TABLE PROPERTY MODIFY code Varchar2(200);

-- Timestamp changes
ALTER TABLE process_instance MODIFY startdate Timestamp;


ALTER TABLE process_instance MODIFY enddate Timestamp; 

ALTER TABLE log_journal MODIFY datelog Timestamp;

ALTER TABLE process MODIFY startdate Timestamp;
ALTER TABLE process MODIFY enddate Timestamp;

ALTER TABLE transition_instance MODIFY transition_start Timestamp;
ALTER TABLE transition_instance MODIFY transition_end Timestamp;

ALTER TABLE rule MODIFY start_date Timestamp;
ALTER TABLE rule MODIFY end_date Timestamp;


------ Differences with Spagic 2.1.0 ------

ALTER TABLE TRANSITION_INSTANCE ADD (attachment_in Integer DEFAULT 0);

ALTER TABLE TRANSITION_INSTANCE ADD (attachment_out Integer DEFAULT 0);

ALTER TABLE PROCESS ADD (monitor_enabled Char(1) DEFAULT 1);

ALTER TABLE TRANSITION_INSTANCE ADD ( transition_data_out BLOB );

------ Tables for event handling ------
Create table wait_data (
	id_wait Integer NOT NULL ,
	id_correlation Varchar2 (200) NOT NULL ,
	wait_timestamp Timestamp NOT NULL ,
	expiry_timestamp Timestamp,
	expiration_action Varchar2 (500),
	eventType Varchar2 (200) Default 'GenericEvent' NOT NULL ,
	exchange Blob,
	signalUri Varchar2 (500),
	destinationUri Varchar2 (500),
primary key (id_wait) 
);

Create table wait_data_attribute (
	id_wait_data_attribute Integer NOT NULL ,
	id_wait Integer NOT NULL ,
	name Varchar2 (200) NOT NULL ,
	att_value Varchar2 (500),
primary key (id_wait_data_attribute) 
);



Alter table wait_data_attribute add  foreign key (id_wait) references wait_data (id_wait);

CREATE SEQUENCE seq_wait_data;

CREATE SEQUENCE seq_wait_data_attribute;



-- Exceution Time ( AZ 09/07/2008 )
ALTER TABLE transition_instance ADD ( transition_execution_time Integer DEFAULT NULL);
ALTER TABLE process_instance ADD ( executiontime Integer DEFAULT NULL);

-- Ricalcola tempi di esecuzione
UPDATE process_instance
SET executiontime = (EXTRACT (DAY from (enddate-startdate))*86400 +
                    EXTRACT(HOUR from (enddate-startdate))*24*60 +
                    EXTRACT(MINUTE from (enddate-startdate))*60 +
                    EXTRACT(SECOND from (enddate-startdate)))*1000; 

-- Changes for Deploy Tool
ALTER TABLE attribute ADD CONSTRAINT UNIQUE name (name);


--
-- Patch to apply to Spagic 2.3.0 to get Search Query Functionality and Binding Component View
-- Apply to Cesena Environment
--

CREATE SEQUENCE seq_search_query;

Create table search_query (
   id_query Integer NOT NULL ,
   label Varchar(100) NOT NULL UNIQUE,
   query Clob NOT NULL,
Primary Key (id_query));


CREATE VIEW bc_input_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS input_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)				
				AND s.id_step = t.id_step_source
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_start = 1 AND logJournal.id_state IN (0, 3)) 
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND logJournal.id_state=3 )
						) 				
	group by s.id_step;

CREATE VIEW bc_output_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS output_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)								
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_end = 1 AND logJournal.id_state=1 AND s.id_step = t.id_step_target)
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND s.id_step = t.id_step_source AND logJournal.id_state=4 )
            OR (s.is_start = 1 AND logJournal.id_state = 4 AND s.id_step = t.id_step_source)						
						) 				
	group by s.id_step;
	
CREATE VIEW bc_error_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS error_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)								
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_start = 1 AND s.id_step = t.id_step_source AND logJournal.id_state IN (2, 5))
						OR(s.is_end = 1 AND s.id_step = t.id_step_target AND logJournal.id_state IN (2, 5))
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND logJournal.id_state=5
								AND (s.id_step = t.id_step_target OR s.id_step = t.id_step_source))
						) 				
	group by s.id_step;


-- Differences with Spagic 2.3.0 --

ALTER TABLE process_instance DROP INDEX idx_correlation_id,
 ADD INDEX idx_process_instance_01 (id_correlation);
/* Cannot be unique due to restarted instances */
Create Index idx_transition_instance_01 ON transition_instance (id_message);
Create Index idx_wait_data_01 ON wait_data (id_correlation);
Create Index idx_log_journal_01 ON log_journal (id_journal);
Create Index idx_log_journal_02 ON log_journal (id_state);
