/*
Created		07/11/2006
Modified		11/07/2007
Project		Spagic
Model		Bck Database
Company		Engineering
Author		Spagic Team
Version		2.0.0
Database    mySQL 5 
*/

Create table process_instance
(
	id_process_instance Bigint NOT NULL,
	id_process Bigint NOT NULL,
	startdate Date NOT NULL,
	enddate Date NOT NULL,
	executiontime Bigint,
	state Integer NOT NULL,
	id_correlation Varchar(100) NOT NULL,
	id_pool Bigint,
 primary key (id_process_instance)
) Without Oids;

Create table transition_instance
(
	id_journal Bigint NOT NULL,
	id_step_source Bigint,
	id_step_target Bigint NOT NULL,
	id_process_instance Bigint NOT NULL,
	id_message Varchar(100) NOT NULL,
	transition_start Date NOT NULL,
	transition_end Date,
	transition_execution_time Bigint,
	id_ext_process_instance Varchar(45),
	id_state Integer NOT NULL,
	transition_data Bytea,
	transition_data_out Bytea,
	attachment_in Integer Default 0,
	attachment_out Integer Default 0,
 primary key (id_journal)
) Without Oids;

Create table log_journal
(
	id_log Bigint NOT NULL,
	id_state Integer NOT NULL,
	id_journal Bigint NOT NULL,
	name Varchar(200),
	log Text NOT NULL,
	datelog Date NOT NULL,
 primary key (id_log)
) Without Oids;

Create table relevant_data
(
	id_relevant_data Bigint NOT NULL,
	id_attribute Bigint NOT NULL,
	id_log Bigint NOT NULL,
	value Varchar(500) NOT NULL,
 primary key (id_relevant_data)
) Without Oids;

Create table pool_instance
(
	id_pool Bigint NOT NULL,
	id_pool_type Bigint NOT NULL,
	unique_pool_instance_key Varchar(1000) NOT NULL,
 primary key (id_pool)
) Without Oids;

Create table relevant_data_process_instance
(
	id_process_instance Bigint NOT NULL,
	id_relevant_data Bigint NOT NULL,
 primary key (id_process_instance,id_relevant_data)
) Without Oids;