/*
Created		07/11/2006
Modified	09/07/2008
Project		Spagic
Model		MetaDB 
Company		Engineering
Author		Spagic Team
Version		2.2.0
Database	mySQL 5 
*/


Create table process_instance (
	id_process_instance Bigint(20) NOT NULL AUTO_INCREMENT,
	id_process Bigint NOT NULL,
	startdate Datetime NOT NULL,
	enddate Datetime NOT NULL,
	executiontime Bigint,
	state Int(11) NOT NULL,
	id_correlation Varchar(100) NOT NULL,
	id_pool Bigint,
 Primary Key (id_process_instance)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table transition_instance (
	id_journal Bigint(20) NOT NULL AUTO_INCREMENT,
	id_step_source Bigint,
	id_step_target Bigint NOT NULL,
	id_process_instance Bigint(20) NOT NULL,
	id_message Varchar(100) NOT NULL,
	transition_start Timestamp NOT NULL,
	transition_end Timestamp,
	transition_execution_time Bigint,
	id_ext_process_instance Varchar(45),
	id_state Int NOT NULL,
	transition_data Mediumblob,
	transition_data_out Mediumblob,
	attachment_in Int DEFAULT 0,
	attachment_out Int DEFAULT 0,
 Primary Key (id_journal)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table log_journal (
	id_log Bigint(20) NOT NULL AUTO_INCREMENT,
	id_state Int NOT NULL,
	id_journal Bigint NOT NULL,
	name Varchar(200),
	log Text NOT NULL,
	datelog Datetime NOT NULL,
 Primary Key (id_log)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table property (
	id_property Bigint(20) NOT NULL AUTO_INCREMENT,
	code Varchar(200) NOT NULL,
	value Varchar(10000) NOT NULL,
 Primary Key (id_property)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table property_process (
	id_property Bigint(20) NOT NULL,
	id_process Bigint NOT NULL,
 Primary Key (id_property,id_process)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table process (
	id_process Bigint(20) NOT NULL AUTO_INCREMENT,
	process_version Varchar(20) NOT NULL,
	namespace Varchar(200) NOT NULL,
	name Varchar(200) NOT NULL,
	description Varchar(200),
	id_ts Bigint(20) NOT NULL,
	uddi_org Varchar(200),
	uddi_name Varchar(200),
	startdate Datetime NOT NULL,
	enddate Datetime,
	state Int(10) UNSIGNED NOT NULL,
	monitor_enabled Bool DEFAULT true,
 Primary Key (id_process)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table step (
	id_step Bigint NOT NULL AUTO_INCREMENT,
	namespace Varchar(200) NOT NULL,
	name Varchar(200) NOT NULL,
	description Varchar(200),
	is_start Bool NOT NULL,
	is_end Bool NOT NULL,
	id_process Bigint NOT NULL,
	process_version Char(20) NOT NULL,
 Primary Key (id_step)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table type_service (
	id_ts Bigint(20) NOT NULL AUTO_INCREMENT,
	value Varchar(45) NOT NULL,
 Primary Key (id_ts)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table property_step (
	id_step Bigint NOT NULL,
	id_property Bigint NOT NULL,
 Primary Key (id_step,id_property)) ENGINE = InnoDB
ROW_FORMAT = Compact;

Create table transition_state (
	id_state Int NOT NULL,
	state_value Varchar(100),
	Index AI_id_state (id_state),
 Primary Key (id_state)) ENGINE = InnoDB;

Create table process_diagram (
	svg_diag Text,
	id_process Bigint NOT NULL,
 Primary Key (id_process)) ENGINE = InnoDB;

Create table rule (
	id_rule Bigint NOT NULL AUTO_INCREMENT,
	id_attribute Bigint,
	transition_state Int NOT NULL,
	condition_expr Varchar(300),
	expr Varchar(300) NOT NULL,
	name Varchar(200) NOT NULL,
	start_date Date,
	end_date Date,
	rule_type Bigint,
	rule_usage Int NOT NULL,
	UNIQUE (name),
	Index AI_id_rule (id_rule),
 Primary Key (id_rule)) ENGINE = InnoDB;

Create table relevant_data (
	id_relevant_data Bigint NOT NULL AUTO_INCREMENT,
	id_attribute Bigint NOT NULL,
	id_log Bigint NOT NULL,
	value Varchar(500) NOT NULL,
 Primary Key (id_relevant_data)) ENGINE = InnoDB;

Create table CSCHEME (
	CSCHEME_ID Varchar(50) NOT NULL,
	CSCHEME_NAME Varchar(100) NOT NULL,
	CSCHEME_DESCRIPTION Varchar(200),
 Primary Key (CSCHEME_ID)) ENGINE = InnoDB;

Create table CSCHEME_VALUES (
	CSCHEME_ID Varchar(50) NOT NULL,
	CSCHEME_VALUE Varchar(200) NOT NULL,
 Primary Key (CSCHEME_ID,CSCHEME_VALUE)) ENGINE = InnoDB;

Create table SERVICE_CLASSIFICATION (
	CSCHEME_ID Varchar(50) NOT NULL,
	CSCHEME_VALUE Varchar(200) NOT NULL,
	service_uddi_org Varchar(200) NOT NULL,
	service_uddi_name Varchar(200) NOT NULL,
 Primary Key (CSCHEME_ID,CSCHEME_VALUE,service_uddi_org,service_uddi_name)) ENGINE = InnoDB;

Create table step_rule (
	id_step Bigint NOT NULL,
	id_rule Bigint NOT NULL,
	order_id Int NOT NULL,
 Primary Key (id_step,id_rule)) ENGINE = InnoDB;

Create table catalog (
	id_catalog Bigint NOT NULL AUTO_INCREMENT,
	name Varchar(200) NOT NULL,
	visible Bool,
	mandatory Bool,
 Primary Key (id_catalog)) ENGINE = InnoDB;

Create table attribute (
	id_attribute Bigint NOT NULL AUTO_INCREMENT,
	name Varchar(50) NOT NULL,
	type Int NOT NULL,
	UNIQUE (name),
 Primary Key (id_attribute)) ENGINE = InnoDB;

Create table transition (
	id_step_source Bigint NOT NULL,
	id_step_target Bigint NOT NULL,
	id_process Bigint NOT NULL,
 Primary Key (id_step_source,id_step_target)) ENGINE = InnoDB;

Create table pool_type (
	id_pool_type Bigint NOT NULL AUTO_INCREMENT,
	id_rule_det_pool_type Bigint,
	name Varchar(200) NOT NULL,
	description Varchar(200) NOT NULL,
	pool_type_version Char(20) NOT NULL,
	Index AI_id_pool_type (id_pool_type),
 Primary Key (id_pool_type)) ENGINE = InnoDB;

Create table pool_instance (
	id_pool Bigint NOT NULL AUTO_INCREMENT,
	id_pool_type Bigint NOT NULL,
	unique_pool_instance_key Varchar(1000) NOT NULL,
 Primary Key (id_pool)) ENGINE = InnoDB;

Create table pool_type_process (
	id_process Bigint NOT NULL,
	order_criteria Int NOT NULL,
	id_pool_type Bigint NOT NULL,
 Primary Key (id_process,id_pool_type)) ENGINE = InnoDB;

Create table relevant_data_process_instance (
	id_process_instance Bigint NOT NULL,
	id_relevant_data Bigint NOT NULL,
 Primary Key (id_process_instance,id_relevant_data)) ENGINE = InnoDB;

Create table xml_namespace (
	id_namespace Bigint NOT NULL AUTO_INCREMENT,
	prefix Varchar(50) NOT NULL,
	value Varchar(200) NOT NULL,
	Index AI_id_namespace (id_namespace),
 Primary Key (id_namespace)) ENGINE = InnoDB;

Create table attribute_pool (
	id_attribute Bigint NOT NULL,
	id_pool_type Bigint NOT NULL,
 Primary Key (id_attribute,id_pool_type)) ENGINE = InnoDB;

Create table attribute_catalog (
	id_attribute Bigint NOT NULL,
	id_catalog Bigint NOT NULL,
	visible Bool,
	order_criteria Int,
 Primary Key (id_attribute,id_catalog)) ENGINE = InnoDB;

Create table wait_data (
	id_wait Bigint(20) NOT NULL AUTO_INCREMENT,
	id_correlation Varchar(200) NOT NULL,
	wait_timestamp Timestamp NOT NULL,
	expiry_timestamp Timestamp NULL DEFAULT NULL,
	expiration_action Varchar(500),
	eventType Varchar(200) NOT NULL DEFAULT "GenericEvent",
	exchange Blob,
	signalUri Varchar(500),
	destinationUri Varchar(500),
 Primary Key (id_wait)) ENGINE = InnoDB;

Create table wait_data_attribute (
	id_wait_data_attribute Bigint NOT NULL AUTO_INCREMENT,
	id_wait Bigint NOT NULL,
	name Varchar(200) NOT NULL,
	att_value Varchar(500),
 Primary Key (id_wait_data_attribute)) ENGINE = InnoDB;

Create table search_query (
   id_query Bigint(20) NOT NULL AUTO_INCREMENT,
   label Varchar(100) NOT NULL UNIQUE,
   query Text NOT NULL,
Primary Key (id_query));

CREATE VIEW bc_input_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS input_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)				
				AND s.id_step = t.id_step_source
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_start = 1 AND logJournal.id_state IN (0, 3)) 
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND logJournal.id_state=3 )
						) 				
	group by s.id_step;
	
CREATE VIEW bc_output_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS output_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)								
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_end = 1 AND logJournal.id_state=1 AND s.id_step = t.id_step_target)
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND s.id_step = t.id_step_source AND logJournal.id_state=4 )
            OR (s.is_start = 1 AND logJournal.id_state = 4 AND s.id_step = t.id_step_source)						
						) 				
	group by s.id_step;
	
CREATE VIEW bc_error_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS error_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)								
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_start = 1 AND s.id_step = t.id_step_source AND logJournal.id_state IN (2, 5))
						OR(s.is_end = 1 AND s.id_step = t.id_step_target AND logJournal.id_state IN (2, 5))
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND logJournal.id_state=5
								AND (s.id_step = t.id_step_target OR s.id_step = t.id_step_source))
						) 				
	group by s.id_step;

Create Index fk_p_sa Using BTREE ON process_instance (id_process);
Create Index fk_jip_p Using BTREE ON transition_instance (id_process_instance);
Create Index fk_sa_ts Using BTREE ON process (id_ts);

Create Index idx_process_instance_01 ON process_instance (id_correlation);
/* Cannot be unique due to restarted instances */
Create Index idx_transition_instance_01 ON transition_instance (id_message);
Create Index idx_wait_data_01 ON wait_data (id_correlation);
Create Index idx_log_journal_01 ON log_journal (id_journal);
Create Index idx_log_journal_02 ON log_journal (id_state);


Alter table transition_instance add Foreign Key (id_process_instance) references process_instance (id_process_instance) on delete  restrict on update  restrict;
Alter table relevant_data_process_instance add Foreign Key (id_process_instance) references process_instance (id_process_instance) on delete  restrict on update  restrict;
Alter table log_journal add Foreign Key (id_journal) references transition_instance (id_journal) on delete  restrict on update  restrict;
Alter table relevant_data add Foreign Key (id_log) references log_journal (id_log) on delete  restrict on update  restrict;
Alter table property_process add Foreign Key (id_property) references property (id_property) on delete  restrict on update  restrict;
Alter table property_step add Foreign Key (id_property) references property (id_property) on delete  restrict on update  restrict;
Alter table process_instance add Foreign Key (id_process) references process (id_process) on delete  restrict on update  restrict;
Alter table property_process add Foreign Key (id_process) references process (id_process) on delete  restrict on update  restrict;
Alter table step add Foreign Key (id_process) references process (id_process) on delete  restrict on update  restrict;
Alter table process_diagram add Foreign Key (id_process) references process (id_process) on delete  restrict on update  restrict;
Alter table transition add Foreign Key (id_process) references process (id_process) on delete  restrict on update  restrict;
Alter table pool_type_process add Foreign Key (id_process) references process (id_process) on delete  restrict on update  restrict;
Alter table transition_instance add Foreign Key (id_step_source) references step (id_step) on delete  restrict on update  restrict;
Alter table property_step add Foreign Key (id_step) references step (id_step) on delete  restrict on update  restrict;
Alter table transition_instance add Foreign Key (id_step_target) references step (id_step) on delete  restrict on update  restrict;
Alter table step_rule add Foreign Key (id_step) references step (id_step) on delete  restrict on update  restrict;
Alter table transition add Foreign Key (id_step_source) references step (id_step) on delete  restrict on update  restrict;
Alter table transition add Foreign Key (id_step_target) references step (id_step) on delete  restrict on update  restrict;
Alter table process add Foreign Key (id_ts) references type_service (id_ts) on delete  restrict on update  restrict;
Alter table transition_instance add Foreign Key (id_state) references transition_state (id_state) on delete  restrict on update  restrict;
Alter table log_journal add Foreign Key (id_state) references transition_state (id_state) on delete  restrict on update  restrict;
Alter table step_rule add Foreign Key (id_rule) references rule (id_rule) on delete  restrict on update  restrict;
Alter table pool_type add Foreign Key (id_rule_det_pool_type) references rule (id_rule) on delete  restrict on update  restrict;
Alter table relevant_data_process_instance add Foreign Key (id_relevant_data) references relevant_data (id_relevant_data) on delete  restrict on update  restrict;
Alter table CSCHEME_VALUES add Foreign Key (CSCHEME_ID) references CSCHEME (CSCHEME_ID) on delete  restrict on update  restrict;
Alter table SERVICE_CLASSIFICATION add Foreign Key (CSCHEME_ID,CSCHEME_VALUE) references CSCHEME_VALUES (CSCHEME_ID,CSCHEME_VALUE) on delete  restrict on update  restrict;
Alter table attribute_catalog add Foreign Key (id_catalog) references catalog (id_catalog) on delete  restrict on update  restrict;
Alter table relevant_data add Foreign Key (id_attribute) references attribute (id_attribute) on delete  restrict on update  restrict;
Alter table rule add Foreign Key (id_attribute) references attribute (id_attribute) on delete  restrict on update  restrict;
Alter table attribute_pool add Foreign Key (id_attribute) references attribute (id_attribute) on delete  restrict on update  restrict;
Alter table attribute_catalog add Foreign Key (id_attribute) references attribute (id_attribute) on delete  restrict on update  restrict;
Alter table pool_instance add Foreign Key (id_pool_type) references pool_type (id_pool_type) on delete  restrict on update  restrict;
Alter table pool_type_process add Foreign Key (id_pool_type) references pool_type (id_pool_type) on delete  restrict on update  restrict;
Alter table attribute_pool add Foreign Key (id_pool_type) references pool_type (id_pool_type) on delete  restrict on update  restrict;
Alter table process_instance add Foreign Key (id_pool) references pool_instance (id_pool) on delete  restrict on update  restrict;
Alter table wait_data_attribute add Foreign Key (id_wait) references wait_data (id_wait) on delete  restrict on update  restrict;


