/*
Created		07/11/2006
Modified	18/04/2008
Project		Spagic
Model		MetaDB 
Company		Engineering
Author		Spagic Team
Version		2.2.0
Database	Oracle 9i 
*/


-- Create Types section


-- Create Tables section


Create table process_instance (
	id_process_instance Integer NOT NULL ,
	id_process Integer NOT NULL ,
	startdate Timestamp NOT NULL ,
	enddate Timestamp NOT NULL ,
	executiontime Integer,
	state Integer NOT NULL ,
	id_correlation Varchar2 (100) NOT NULL ,
	id_pool Integer,
primary key (id_process_instance) 
) 
;

Create table transition_instance (
	id_journal Integer NOT NULL ,
	id_step_source Integer,
	id_step_target Integer NOT NULL ,
	id_process_instance Integer NOT NULL ,
	id_message Varchar2 (100) NOT NULL ,
	transition_start Timestamp NOT NULL ,
	transition_end Timestamp,
	transition_execution_time Integer,
	id_ext_process_instance Varchar2 (45),
	id_state Integer NOT NULL ,
	transition_data Blob,
	transition_data_out Blob,
	attachment_in Integer Default 0,
	attachment_out Integer Default 0,
primary key (id_journal) 
) 
;

Create table log_journal (
	id_log Integer NOT NULL ,
	id_state Integer NOT NULL ,
	id_journal Integer NOT NULL ,
	name Varchar2 (200),
	log Clob NOT NULL ,
	datelog Timestamp NOT NULL ,
primary key (id_log) 
) 
;

Create table property (
	id_property Integer NOT NULL ,
	code Varchar2 (200) NOT NULL ,
	value Varchar2 (4000) NOT NULL ,
primary key (id_property) 
) 
;

Create table property_process (
	id_property Integer NOT NULL ,
	id_process Integer NOT NULL ,
primary key (id_property,id_process) 
) 
;

Create table process (
	id_process Integer NOT NULL ,
	process_version Varchar2 (20) NOT NULL ,
	namespace Varchar2 (200) NOT NULL ,
	name Varchar2 (200) NOT NULL ,
	description Varchar2 (200),
	id_ts Integer NOT NULL ,
	uddi_org Varchar2 (200),
	uddi_name Varchar2 (200),
	startdate Timestamp NOT NULL ,
	enddate Timestamp,
	state Integer NOT NULL ,
	monitor_enabled Char (1) Default 1,
primary key (id_process) 
) 
;

Create table step (
	id_step Integer NOT NULL ,
	namespace Varchar2 (200) NOT NULL ,
	name Varchar2 (200) NOT NULL ,
	description Varchar2 (200),
	is_start Char (1) NOT NULL ,
	is_end Char (1) NOT NULL ,
	id_process Integer NOT NULL ,
	process_version Char (20) NOT NULL ,
primary key (id_step) 
) 
;

Create table type_service (
	id_ts Integer NOT NULL ,
	value Varchar2 (45) NOT NULL ,
primary key (id_ts) 
) 
;

Create table property_step (
	id_step Integer NOT NULL ,
	id_property Integer NOT NULL ,
primary key (id_step,id_property) 
) 
;

Create table transition_state (
	id_state Integer NOT NULL ,
	state_value Varchar2 (100),
primary key (id_state) 
) 
;

Create table process_diagram (
	svg_diag Clob,
	id_process Integer NOT NULL ,
primary key (id_process) 
) 
;

Create table rule (
	id_rule Integer NOT NULL ,
	id_attribute Integer,
	transition_state Integer NOT NULL ,
	condition_expr Varchar2 (300),
	expr Varchar2 (300) NOT NULL ,
	name Varchar2 (200) NOT NULL  UNIQUE ,
	start_date Timestamp,
	end_date Timestamp,
	rule_type Integer,
	rule_usage Integer NOT NULL ,
primary key (id_rule) 
) 
;

Create table relevant_data (
	id_relevant_data Integer NOT NULL ,
	id_attribute Integer NOT NULL ,
	id_log Integer NOT NULL ,
	value Varchar2 (500) NOT NULL ,
primary key (id_relevant_data) 
) 
;

Create table CSCHEME (
	CSCHEME_ID Varchar2 (50) NOT NULL ,
	CSCHEME_NAME Varchar2 (100) NOT NULL ,
	CSCHEME_DESCRIPTION Varchar2 (200),
primary key (CSCHEME_ID) 
) 
;

Create table CSCHEME_VALUES (
	CSCHEME_ID Varchar2 (50) NOT NULL ,
	CSCHEME_VALUE Varchar2 (200) NOT NULL ,
primary key (CSCHEME_ID,CSCHEME_VALUE) 
) 
;

Create table SERVICE_CLASSIFICATION (
	CSCHEME_ID Varchar2 (50) NOT NULL ,
	CSCHEME_VALUE Varchar2 (200) NOT NULL ,
	service_uddi_org Varchar2 (200) NOT NULL ,
	service_uddi_name Varchar2 (200) NOT NULL ,
primary key (CSCHEME_ID,CSCHEME_VALUE,service_uddi_org,service_uddi_name) 
) 
;

Create table step_rule (
	id_step Integer NOT NULL ,
	id_rule Integer NOT NULL ,
	order_id Integer NOT NULL ,
primary key (id_step,id_rule) 
) 
;

Create table catalog (
	id_catalog Integer NOT NULL ,
	name Varchar2 (200) NOT NULL ,
	visible Char (1),
	mandatory Char (1),
primary key (id_catalog) 
) 
;

Create table attribute (
	id_attribute Integer NOT NULL ,
	name Varchar2 (50) NOT NULL  UNIQUE ,
	type Integer NOT NULL ,
primary key (id_attribute) 
) 
;

Create table transition (
	id_step_source Integer NOT NULL ,
	id_step_target Integer NOT NULL ,
	id_process Integer NOT NULL ,
primary key (id_step_source,id_step_target) 
) 
;

Create table pool_type (
	id_pool_type Integer NOT NULL ,
	id_rule_det_pool_type Integer,
	name Varchar2 (200) NOT NULL ,
	description Varchar2 (200) NOT NULL ,
	pool_type_version Char (20) NOT NULL ,
primary key (id_pool_type) 
) 
;

Create table pool_instance (
	id_pool Integer NOT NULL ,
	id_pool_type Integer NOT NULL ,
	unique_pool_instance_key Varchar2 (1000) NOT NULL ,
primary key (id_pool) 
) 
;

Create table pool_type_process (
	id_process Integer NOT NULL ,
	order_criteria Integer NOT NULL ,
	id_pool_type Integer NOT NULL ,
primary key (id_process,id_pool_type) 
) 
;

Create table relevant_data_process_instance (
	id_process_instance Integer NOT NULL ,
	id_relevant_data Integer NOT NULL ,
primary key (id_process_instance,id_relevant_data) 
) 
;

Create table xml_namespace (
	id_namespace Integer NOT NULL ,
	prefix Varchar2 (50) NOT NULL ,
	value Varchar2 (200) NOT NULL ,
primary key (id_namespace) 
) 
;

Create table attribute_pool (
	id_attribute Integer NOT NULL ,
	id_pool_type Integer NOT NULL ,
primary key (id_attribute,id_pool_type) 
) 
;

Create table attribute_catalog (
	id_attribute Integer NOT NULL ,
	id_catalog Integer NOT NULL ,
	visible Char (1),
	order_criteria Integer,
primary key (id_attribute,id_catalog) 
) 
;

Create table wait_data (
	id_wait Integer NOT NULL ,
	id_correlation Varchar2 (200) NOT NULL ,
	wait_timestamp Timestamp NOT NULL ,
	expiry_timestamp Timestamp,
	expiration_action Varchar2 (500),
	eventType Varchar2 (200) Default 'GenericEvent' NOT NULL ,
	exchange Blob,
	signalUri Varchar2 (500),
	destinationUri Varchar2 (500),
primary key (id_wait) 
) 
;

Create table wait_data_attribute (
	id_wait_data_attribute Integer NOT NULL ,
	id_wait Integer NOT NULL ,
	name Varchar2 (200) NOT NULL ,
	att_value Varchar2 (500),
primary key (id_wait_data_attribute) 
) 
;

Create table search_query (
   id_query Integer NOT NULL ,
   label Varchar(100) NOT NULL UNIQUE,
   query Blob NOT NULL,
Primary Key (id_query)
)
;

-- Create View section
CREATE VIEW bc_input_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS input_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)				
				AND s.id_step = t.id_step_source
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_start = 1 AND logJournal.id_state IN (0, 3)) 
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND logJournal.id_state=3 )
						) 				
	group by s.id_step;

CREATE VIEW bc_output_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS output_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)								
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_end = 1 AND logJournal.id_state=1 AND s.id_step = t.id_step_target)
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND s.id_step = t.id_step_source AND logJournal.id_state=4 )
            OR (s.is_start = 1 AND logJournal.id_state = 4 AND s.id_step = t.id_step_source)						
						) 				
	group by s.id_step;
	
CREATE VIEW bc_error_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS error_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)								
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_start = 1 AND s.id_step = t.id_step_source AND logJournal.id_state IN (2, 5))
						OR(s.is_end = 1 AND s.id_step = t.id_step_target AND logJournal.id_state IN (2, 5))
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND logJournal.id_state=5
								AND (s.id_step = t.id_step_target OR s.id_step = t.id_step_source))
						) 				
	group by s.id_step;


-- Create Indexes section

Create Index fk_p_sa ON process_instance (id_process);
Create Index fk_jip_p ON transition_instance (id_process_instance);
Create Index fk_sa_ts ON process (id_ts);

Create Index idx_process_instance_01 ON process_instance (id_correlation);
/* Cannot be unique due to restarted instances */
Create Index idx_transition_instance_01 ON transition_instance (id_message);
Create Index idx_wait_data_01 ON wait_data (id_correlation);
Create Index idx_log_journal_01 ON log_journal (id_journal);
Create Index idx_log_journal_02 ON log_journal (id_state);


-- Create Foreign keys section

Alter table transition_instance add  foreign key (id_process_instance) references process_instance (id_process_instance) 
;

Alter table relevant_data_process_instance add  foreign key (id_process_instance) references process_instance (id_process_instance) 
;

Alter table log_journal add  foreign key (id_journal) references transition_instance (id_journal) 
;

Alter table relevant_data add  foreign key (id_log) references log_journal (id_log) 
;

Alter table property_process add  foreign key (id_property) references property (id_property) 
;

Alter table property_step add  foreign key (id_property) references property (id_property) 
;

Alter table process_instance add  foreign key (id_process) references process (id_process) 
;

Alter table property_process add  foreign key (id_process) references process (id_process) 
;

Alter table step add  foreign key (id_process) references process (id_process) 
;

Alter table process_diagram add  foreign key (id_process) references process (id_process) 
;

Alter table transition add  foreign key (id_process) references process (id_process) 
;

Alter table pool_type_process add  foreign key (id_process) references process (id_process) 
;

Alter table transition_instance add  foreign key (id_step_source) references step (id_step) 
;

Alter table property_step add  foreign key (id_step) references step (id_step) 
;

Alter table transition_instance add  foreign key (id_step_target) references step (id_step) 
;

Alter table step_rule add  foreign key (id_step) references step (id_step) 
;

Alter table transition add  foreign key (id_step_source) references step (id_step) 
;

Alter table transition add  foreign key (id_step_target) references step (id_step) 
;

Alter table process add  foreign key (id_ts) references type_service (id_ts) 
;

Alter table transition_instance add  foreign key (id_state) references transition_state (id_state) 
;

Alter table log_journal add  foreign key (id_state) references transition_state (id_state) 
;

Alter table step_rule add  foreign key (id_rule) references rule (id_rule) 
;

Alter table pool_type add  foreign key (id_rule_det_pool_type) references rule (id_rule) 
;

Alter table relevant_data_process_instance add  foreign key (id_relevant_data) references relevant_data (id_relevant_data) 
;

Alter table CSCHEME_VALUES add  foreign key (CSCHEME_ID) references CSCHEME (CSCHEME_ID) 
;

Alter table SERVICE_CLASSIFICATION add  foreign key (CSCHEME_ID,CSCHEME_VALUE) references CSCHEME_VALUES (CSCHEME_ID,CSCHEME_VALUE) 
;

Alter table attribute_catalog add  foreign key (id_catalog) references catalog (id_catalog) 
;

Alter table relevant_data add  foreign key (id_attribute) references attribute (id_attribute) 
;

Alter table rule add  foreign key (id_attribute) references attribute (id_attribute) 
;

Alter table attribute_pool add  foreign key (id_attribute) references attribute (id_attribute) 
;

Alter table attribute_catalog add  foreign key (id_attribute) references attribute (id_attribute) 
;

Alter table pool_instance add  foreign key (id_pool_type) references pool_type (id_pool_type) 
;

Alter table pool_type_process add  foreign key (id_pool_type) references pool_type (id_pool_type) 
;

Alter table attribute_pool add  foreign key (id_pool_type) references pool_type (id_pool_type) 
;

Alter table process_instance add  foreign key (id_pool) references pool_instance (id_pool) 
;

Alter table wait_data_attribute add  foreign key (id_wait) references wait_data (id_wait) 
;


-- Create Object Tables section


-- Create XMLType Tables section


-- Create Functions section


-- Create Sequences section

-- Create Sequences section
CREATE SEQUENCE seq_process_instance;

CREATE SEQUENCE seq_transition_instance;

CREATE SEQUENCE seq_log_journal;

CREATE SEQUENCE seq_property;

CREATE SEQUENCE seq_property_process;

CREATE SEQUENCE seq_process;

CREATE SEQUENCE seq_step;

CREATE SEQUENCE seq_type_service;

CREATE SEQUENCE seq_property_step;

CREATE SEQUENCE seq_transition_state;

CREATE SEQUENCE seq_process_diagram;

CREATE SEQUENCE seq_rule;

CREATE SEQUENCE seq_relevant_data;

CREATE SEQUENCE seq_CSCHEME;

CREATE SEQUENCE seq_CSCHEME_VALUES;

CREATE SEQUENCE seq_SERVICE_CLASSIFICATION;

CREATE SEQUENCE seq_step_rule;

CREATE SEQUENCE seq_catalog;

CREATE SEQUENCE seq_attribute;

CREATE SEQUENCE seq_transition;

CREATE SEQUENCE seq_pool_type;

CREATE SEQUENCE seq_pool_instance;

CREATE SEQUENCE seq_pool_type_process;

CREATE SEQUENCE seq_xml_namespace;

CREATE SEQUENCE seq_attribute_pool;

CREATE SEQUENCE seq_attribute_catalog;

CREATE SEQUENCE seq_wait_data;

CREATE SEQUENCE seq_wait_data_attribute;

CREATE SEQUENCE seq_search_query;


-- Create Triggers from referential integrity section


-- Create user Triggers section


-- Create Packages section


-- Create Synonyms section


-- Create Table comments section

Comment on table process_instance is 'Tabella di auditing.
Per ciascuna istanza di processo esiste una riga in questa tabella.'
;
Comment on table transition_instance is 'Tabella di auditing.
Per ciascun endpoint GIA'' UTILIZZATO nel service assembly esiste una riga in questa tabella.'
;
Comment on table log_journal is 'Tabella di auditing.
Nel caso sia configurato il tracciamento dei messaggi, questa tabella viene utilizzata a tal scopo.'
;
Comment on table process is 'Tabella di configurazione.
Censisce tutti i PROCESSI.'
;
Comment on table step is 'Tabella di configurazione.
Per ciascun processo (service_assembly) censisce gli ENDPOINT associati a ciascun componente (service).
Un componente utilizzato in processi diversi genera Endpoint diversi.

Se un componente viene utilizzato in 10 processi, ad esempio, sar censito come segue nel database:
   - 1 riga in "service" per censire il componente
   - 10 righe in "service_assembly" per censire i 10 processi
   - 10 righe (ALMENO) in "endpoint" per censire i 10 utilizzi del componente nei 10 processi

L''utilizzo di un componente in un processo pu generare pi Endpoint: questo  vero per i Binding Component di avvio dei processi (vedi concetto di external e internal endpoint).'
;
Comment on table type_service is 'Tabella di configurazione.
Censice i TIPI DI COMPONENTE, ad esempio "Binding Component" o "Service Engine".'
;
Comment on table transition_state is 'Possibili stati delle transizioni.

Per JBI equivalgono agli stati supportati per i 4 MEP:

MEP In-Only
  - Active
  - Done
  - Fault.

MEP Robust In-Only
  - Active
  - Done
  - Fault

MEP In-Out
  - Active
  - Out
  - Fault

MEP In Optional-Out
  - Active
  - Out
  - Fault
  - Done

Per BPEL attualmente abbiamo un solo stato:
  - Sent'
;
Comment on table step_rule is 'Tabella di configurazione.
Tabella associativa tra gli ENDPOINT (endpoint) e le REGOLE (rules): contiene le regole da utilizzarsi per ciascun processo.
Tale tabella viene valorizzata alla definizione del processo, con le regole preconfigurate in "service_rules".'
;
Comment on table catalog is 'Tabella di configurazione (Metadati).
Classificazione degli attributi secondo raggruppamenti logici.'
;
Comment on table attribute is 'Tabella di configurazione (Metadati).
Contiene tutte le tipologie di attributi corrispondenti ai dati rilevanti.'
;
Comment on table transition is 'Tabella di configurazione.
A ciascuna transizione nel grafo di descrizione del processo, corrisponde una riga di questa tabella.'
;
Comment on table pool_type is 'Tabella di configurazione.
Censisce le tipologie di iter disponibili.'
;
Comment on table pool_instance is 'Tabella di auditing.
Censisce tutte le istanze di iter.'
;

-- Create Attribute comments section

Comment on column process_instance.state is 'Stato dell''istanza: 
- Attivo
- Terminato
- Terminato con errore'
;
Comment on column process_instance.id_correlation is 'Correlation Id necessario a tracciare il flusso degli Exchange in ServiceMix. Non  la chiave primaria in quanto non  assicurato che ServiceMix generi identificatori sempre diverso, ad esempio in caso di riavvio del server.'
;
Comment on column transition_instance.id_process_instance is 'Riferimento al Service Assembly'
;
Comment on column transition_instance.id_message is 'Identificatore del messaggio'
;
Comment on column transition_instance.transition_start is 'Istante di invio dell''exchange con stato Active.'
;
Comment on column transition_instance.transition_end is 'Istante di invio dell''exchange con stato Done.'
;
Comment on column transition_instance.id_ext_process_instance is 'Riferimento all''identificatore del processo esterno, ad esempio un processo BPEL, non tracciabile dal listener.'
;
Comment on column transition_instance.id_state is 'Stato corrente del message exchange'
;
Comment on column log_journal.name is 'Name of this XML flow, to be used in the console, if available.'
;
Comment on column process.name is 'Process name'
;
Comment on column process.uddi_org is 'UDDI organization name (if any).'
;
Comment on column process.uddi_name is 'UDDI service name (if any).'
;
Comment on column process.startdate is 'Validity start date.'
;
Comment on column process.enddate is 'Validity end date.'
;
Comment on column process.state is 'Specify the process state (ACTIVE, INACTIVE, etc).'
;
Comment on column process.monitor_enabled is 'Specify if the process has to be monitored'
;
Comment on column rule.id_attribute is 'Tipo di attributo che questa regola genera'
;
Comment on column rule.transition_state is 'Indica a quale tipo di messaggio nel MEP va applicata la regola.
Valori previsti:
- 0: IN (si applica a tutti i MEP)
- 1: OUT (si applica ai MEP IN-OUT e IN-OPTIONAL-OUT)
- 2: IN-OUT
'
;
Comment on column rule.condition_expr is 'Precondizione XPath'
;
Comment on column rule.expr is 'Espressione XPath'
;
Comment on column rule.start_date is 'Data inizio applicabilit regola'
;
Comment on column rule.end_date is 'Data fine applicabilit regola'
;
Comment on column rule.rule_type is 'Tipo di regola: 
1. Espressione XPath
2. Espressione Drools
3. Espressione Groovy
'
;
Comment on column rule.rule_usage is 'Scopo della regola.
Valori possibili:
- 0: estrazione dati
- 1: determinazione tipo iter'
;
Comment on column xml_namespace.prefix is 'The namespace alias
'
;


