/*
Created		07/11/2006
Modified	28/07/2008
Project		Spagic
Model		MetaDB 
Company		Engineering
Author		Spagic Team
Version		2.2.0
Database	PostgreSQL 8.1 
*/


/* Create Sequences */

CREATE SEQUENCE spagic.seq_process_instance;

CREATE SEQUENCE spagic.seq_transition_instance;

CREATE SEQUENCE spagic.seq_log_journal;

CREATE SEQUENCE spagic.seq_property;

CREATE SEQUENCE spagic.seq_property_process;

CREATE SEQUENCE spagic.seq_process;

CREATE SEQUENCE spagic.seq_step;

CREATE SEQUENCE spagic.seq_type_service;

CREATE SEQUENCE spagic.seq_property_step;

CREATE SEQUENCE spagic.seq_transition_state;

CREATE SEQUENCE spagic.seq_process_diagram;

CREATE SEQUENCE spagic.seq_rule;

CREATE SEQUENCE spagic.seq_relevant_data;

CREATE SEQUENCE spagic.seq_CSCHEME;

CREATE SEQUENCE spagic.seq_CSCHEME_VALUES;

CREATE SEQUENCE spagic.seq_SERVICE_CLASSIFICATION;

CREATE SEQUENCE spagic.seq_step_rule;

CREATE SEQUENCE spagic.seq_catalog;

CREATE SEQUENCE spagic.seq_attribute;

CREATE SEQUENCE spagic.seq_transition;

CREATE SEQUENCE spagic.seq_pool_type;

CREATE SEQUENCE spagic.seq_pool_instance;

CREATE SEQUENCE spagic.seq_pool_type_process;

CREATE SEQUENCE spagic.seq_xml_namespace;

CREATE SEQUENCE spagic.seq_attribute_pool;

CREATE SEQUENCE spagic.seq_attribute_catalog;

CREATE SEQUENCE spagic.seq_wait_data;

CREATE SEQUENCE spagic.seq_wait_data_attribute;

CREATE SEQUENCE spagic.seq_search_query;

/* Create Tables */

Create table process_instance
(
	id_process_instance Bigint NOT NULL,
	id_process Bigint NOT NULL,
	startdate Date NOT NULL,
	enddate Date NOT NULL,
	executiontime Bigint,
	state Integer NOT NULL,
	id_correlation Varchar(100) NOT NULL,
	id_pool Bigint,
 primary key (id_process_instance)
) Without Oids;


Create table transition_instance
(
	id_journal Bigint NOT NULL,
	id_step_source Bigint,
	id_step_target Bigint NOT NULL,
	id_process_instance Bigint NOT NULL,
	id_message Varchar(100) NOT NULL,
	transition_start Date NOT NULL,
	transition_end Date,
	transition_execution_time Bigint,
	id_ext_process_instance Varchar(45),
	id_state Integer NOT NULL,
	transition_data Bytea,
	transition_data_out Bytea,
	attachment_in Integer Default 0,
	attachment_out Integer Default 0,
 primary key (id_journal)
) Without Oids;


Create table log_journal
(
	id_log Bigint NOT NULL,
	id_state Integer NOT NULL,
	id_journal Bigint NOT NULL,
	name Varchar(200),
	log Text NOT NULL,
	datelog Date NOT NULL,
 primary key (id_log)
) Without Oids;


Create table property
(
	id_property Bigint NOT NULL,
	code Varchar(200) NOT NULL,
	value Varchar(10000) NOT NULL,
 primary key (id_property)
) Without Oids;


Create table property_process
(
	id_property Bigint NOT NULL,
	id_process Bigint NOT NULL,
 primary key (id_property,id_process)
) Without Oids;


Create table process
(
	id_process Bigint NOT NULL,
	process_version Varchar(20) NOT NULL,
	namespace Varchar(200) NOT NULL,
	name Varchar(200) NOT NULL,
	description Varchar(200),
	id_ts Bigint NOT NULL,
	uddi_org Varchar(200),
	uddi_name Varchar(200),
	startdate Date NOT NULL,
	enddate Date,
	state Integer NOT NULL,
	monitor_enabled Boolean Default true,
 primary key (id_process)
) Without Oids;


Create table step
(
	id_step Bigint NOT NULL,
	namespace Varchar(200) NOT NULL,
	name Varchar(200) NOT NULL,
	description Varchar(200),
	is_start Boolean NOT NULL,
	is_end Boolean NOT NULL,
	id_process Bigint NOT NULL,
	process_version Char(20) NOT NULL,
 primary key (id_step)
) Without Oids;


Create table type_service
(
	id_ts Bigint NOT NULL,
	value Varchar(45) NOT NULL,
 primary key (id_ts)
) Without Oids;


Create table property_step
(
	id_step Bigint NOT NULL,
	id_property Bigint NOT NULL,
 primary key (id_step,id_property)
) Without Oids;


Create table transition_state
(
	id_state Integer NOT NULL,
	state_value Varchar(100),
 primary key (id_state)
) Without Oids;


Create table process_diagram
(
	svg_diag Text,
	id_process Bigint NOT NULL,
 primary key (id_process)
) Without Oids;


Create table rule
(
	id_rule Bigint NOT NULL,
	id_attribute Bigint,
	transition_state Integer NOT NULL,
	condition_expr Varchar(300),
	expr Varchar(300) NOT NULL,
	name Varchar(200) NOT NULL UNIQUE,
	start_date Date,
	end_date Date,
	rule_type Bigint,
	rule_usage Integer NOT NULL,
 primary key (id_rule)
) Without Oids;


Create table relevant_data
(
	id_relevant_data Bigint NOT NULL,
	id_attribute Bigint NOT NULL,
	id_log Bigint NOT NULL,
	value Varchar(500) NOT NULL,
 primary key (id_relevant_data)
) Without Oids;


Create table CSCHEME
(
	CSCHEME_ID Varchar(50) NOT NULL,
	CSCHEME_NAME Varchar(100) NOT NULL,
	CSCHEME_DESCRIPTION Varchar(200),
 primary key (CSCHEME_ID)
) Without Oids;


Create table CSCHEME_VALUES
(
	CSCHEME_ID Varchar(50) NOT NULL,
	CSCHEME_VALUE Varchar(200) NOT NULL,
 primary key (CSCHEME_ID,CSCHEME_VALUE)
) Without Oids;


Create table SERVICE_CLASSIFICATION
(
	CSCHEME_ID Varchar(50) NOT NULL,
	CSCHEME_VALUE Varchar(200) NOT NULL,
	service_uddi_org Varchar(200) NOT NULL,
	service_uddi_name Varchar(200) NOT NULL,
 primary key (CSCHEME_ID,CSCHEME_VALUE,service_uddi_org,service_uddi_name)
) Without Oids;


Create table step_rule
(
	id_step Bigint NOT NULL,
	id_rule Bigint NOT NULL,
	order_id Integer NOT NULL,
 primary key (id_step,id_rule)
) Without Oids;


Create table catalog
(
	id_catalog Bigint NOT NULL,
	name Varchar(200) NOT NULL,
	visible Boolean,
	mandatory Boolean,
 primary key (id_catalog)
) Without Oids;


Create table attribute
(
	id_attribute Bigint NOT NULL,
	name Varchar(50) NOT NULL UNIQUE,
	type Integer NOT NULL,
 primary key (id_attribute)
) Without Oids;


Create table transition
(
	id_step_source Bigint NOT NULL,
	id_step_target Bigint NOT NULL,
	id_process Bigint NOT NULL,
 primary key (id_step_source,id_step_target)
) Without Oids;


Create table pool_type
(
	id_pool_type Bigint NOT NULL,
	id_rule_det_pool_type Bigint,
	name Varchar(200) NOT NULL,
	description Varchar(200) NOT NULL,
	pool_type_version Char(20) NOT NULL,
 primary key (id_pool_type)
) Without Oids;


Create table pool_instance
(
	id_pool Bigint NOT NULL,
	id_pool_type Bigint NOT NULL,
	unique_pool_instance_key Varchar(1000) NOT NULL,
 primary key (id_pool)
) Without Oids;


Create table pool_type_process
(
	id_process Bigint NOT NULL,
	order_criteria Integer NOT NULL,
	id_pool_type Bigint NOT NULL,
 primary key (id_process,id_pool_type)
) Without Oids;


Create table relevant_data_process_instance
(
	id_process_instance Bigint NOT NULL,
	id_relevant_data Bigint NOT NULL,
 primary key (id_process_instance,id_relevant_data)
) Without Oids;


Create table xml_namespace
(
	id_namespace Bigint NOT NULL,
	prefix Varchar(50) NOT NULL,
	value Varchar(200) NOT NULL,
 primary key (id_namespace)
) Without Oids;


Create table attribute_pool
(
	id_attribute Bigint NOT NULL,
	id_pool_type Bigint NOT NULL,
 primary key (id_attribute,id_pool_type)
) Without Oids;


Create table attribute_catalog
(
	id_attribute Bigint NOT NULL,
	id_catalog Bigint NOT NULL,
	visible Boolean,
	order_criteria Integer,
 primary key (id_attribute,id_catalog)
) Without Oids;


Create table wait_data
(
	id_wait Bigint NOT NULL,
	id_correlation Varchar(200) NOT NULL,
	wait_timestamp Date NOT NULL,
	expiry_timestamp Date,
	expiration_action Varchar(500),
	eventType Varchar(200) NOT NULL Default 'GenericEvent',
	exchange Bytea,
	signalUri Varchar(500),
	destinationUri Varchar(500),
 primary key (id_wait)
) Without Oids;


Create table wait_data_attribute
(
	id_wait_data_attribute Bigint NOT NULL,
	id_wait Bigint NOT NULL,
	name Varchar(200) NOT NULL,
	att_value Varchar(500),
 primary key (id_wait_data_attribute)
) Without Oids;

Create table search_query (
   id_query Integer NOT NULL ,
   label Varchar(100) NOT NULL UNIQUE,
   query Text NOT NULL,
Primary Key (id_query)
) Without Oids;

-- Create view section
CREATE VIEW bc_input_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS input_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)				
				AND s.id_step = t.id_step_source
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_start AND logJournal.id_state IN (0, 3)) 
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND logJournal.id_state=3 )
						) 				
	group by s.id_step;

CREATE VIEW bc_output_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS output_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)								
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_end AND logJournal.id_state=1 AND s.id_step = t.id_step_target)
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND s.id_step = t.id_step_source AND logJournal.id_state=4 )
            OR (s.is_start AND logJournal.id_state = 4 AND s.id_step = t.id_step_source)						
						) 				
	group by s.id_step;
	
CREATE VIEW bc_error_messages AS
  SELECT s.id_step AS id_binding_component, COUNT(logJournal.id_log) AS error_messages 
	FROM step s, process p, transition_instance t, log_journal logJournal,property_step propertyStep, property pty  	
	WHERE s.id_process = p.id_process AND s.id_process = (SELECT max(pSub.id_process) AS idProcess FROM process pSub WHERE pSub.name=p.name)								
				AND t.id_journal = logJournal.id_journal 				
				AND s.id_step=propertyStep.id_step 				
				AND propertyStep.id_property=pty.id_property
				AND pty.code='im.servicebindingname'
				AND ((s.is_start AND s.id_step = t.id_step_source AND logJournal.id_state IN (2, 5))
						OR(s.is_end  AND s.id_step = t.id_step_target AND logJournal.id_state IN (2, 5))
						OR (pty.value IN ('JBI-WebServicePipeline','JBI-TCPIP-Pipeline','JBI-CXF-Pipeline') AND logJournal.id_state=5
								AND (s.id_step = t.id_step_target OR s.id_step = t.id_step_source))
						) 				
	group by s.id_step;


/* Create Indexes */
Create index fk_p_sa on process_instance using btree (id_process);
Create index fk_jip_p on transition_instance using btree (id_process_instance);
Create index fk_sa_ts on process using btree (id_ts);

Create index idx_process_instance_01 on process_instance using btree (id_correlation);
/* Cannot be unique due to restarted instances */
Create Index idx_transition_instance_01 ON transition_instance using btree (id_message);
Create Index idx_wait_data_01 ON wait_data using btree (id_correlation);
Create Index idx_log_journal_01 ON log_journal using btree (id_journal);
Create Index idx_log_journal_02 ON log_journal using btree (id_state);


/* Create Foreign Keys */

Alter table transition_instance add  foreign key (id_process_instance) references process_instance (id_process_instance) on update restrict on delete restrict;

Alter table relevant_data_process_instance add  foreign key (id_process_instance) references process_instance (id_process_instance) on update restrict on delete restrict;

Alter table log_journal add  foreign key (id_journal) references transition_instance (id_journal) on update restrict on delete restrict;

Alter table relevant_data add  foreign key (id_log) references log_journal (id_log) on update restrict on delete restrict;

Alter table property_process add  foreign key (id_property) references property (id_property) on update restrict on delete restrict;

Alter table property_step add  foreign key (id_property) references property (id_property) on update restrict on delete restrict;

Alter table process_instance add  foreign key (id_process) references process (id_process) on update restrict on delete restrict;

Alter table property_process add  foreign key (id_process) references process (id_process) on update restrict on delete restrict;

Alter table step add  foreign key (id_process) references process (id_process) on update restrict on delete restrict;

Alter table process_diagram add  foreign key (id_process) references process (id_process) on update restrict on delete restrict;

Alter table transition add  foreign key (id_process) references process (id_process) on update restrict on delete restrict;

Alter table pool_type_process add  foreign key (id_process) references process (id_process) on update restrict on delete restrict;

Alter table transition_instance add  foreign key (id_step_source) references step (id_step) on update restrict on delete restrict;

Alter table property_step add  foreign key (id_step) references step (id_step) on update restrict on delete restrict;

Alter table transition_instance add  foreign key (id_step_target) references step (id_step) on update restrict on delete restrict;

Alter table step_rule add  foreign key (id_step) references step (id_step) on update restrict on delete restrict;

Alter table transition add  foreign key (id_step_source) references step (id_step) on update restrict on delete restrict;

Alter table transition add  foreign key (id_step_target) references step (id_step) on update restrict on delete restrict;

Alter table process add  foreign key (id_ts) references type_service (id_ts) on update restrict on delete restrict;

Alter table transition_instance add  foreign key (id_state) references transition_state (id_state) on update restrict on delete restrict;

Alter table log_journal add  foreign key (id_state) references transition_state (id_state) on update restrict on delete restrict;

Alter table step_rule add  foreign key (id_rule) references rule (id_rule) on update restrict on delete restrict;

Alter table pool_type add  foreign key (id_rule_det_pool_type) references rule (id_rule) on update restrict on delete restrict;

Alter table relevant_data_process_instance add  foreign key (id_relevant_data) references relevant_data (id_relevant_data) on update restrict on delete restrict;

Alter table CSCHEME_VALUES add  foreign key (CSCHEME_ID) references CSCHEME (CSCHEME_ID) on update restrict on delete restrict;

Alter table SERVICE_CLASSIFICATION add  foreign key (CSCHEME_ID,CSCHEME_VALUE) references CSCHEME_VALUES (CSCHEME_ID,CSCHEME_VALUE) on update restrict on delete restrict;

Alter table attribute_catalog add  foreign key (id_catalog) references catalog (id_catalog) on update restrict on delete restrict;

Alter table relevant_data add  foreign key (id_attribute) references attribute (id_attribute) on update restrict on delete restrict;

Alter table rule add  foreign key (id_attribute) references attribute (id_attribute) on update restrict on delete restrict;

Alter table attribute_pool add  foreign key (id_attribute) references attribute (id_attribute) on update restrict on delete restrict;

Alter table attribute_catalog add  foreign key (id_attribute) references attribute (id_attribute) on update restrict on delete restrict;

Alter table pool_instance add  foreign key (id_pool_type) references pool_type (id_pool_type) on update restrict on delete restrict;

Alter table pool_type_process add  foreign key (id_pool_type) references pool_type (id_pool_type) on update restrict on delete restrict;

Alter table attribute_pool add  foreign key (id_pool_type) references pool_type (id_pool_type) on update restrict on delete restrict;

Alter table process_instance add  foreign key (id_pool) references pool_instance (id_pool) on update restrict on delete restrict;

Alter table wait_data_attribute add  foreign key (id_wait) references wait_data (id_wait) on update restrict on delete restrict;


/* Create Referential Integrity Triggers */


